require(['config'], function() {
	require([
		'jquery'
	], function($) {

	});
});

let NK_DID_EQUIP_GRID_LIST = '/api/nk/did/disp-grid-list';

function itp_fn_BIZPOP_NK_EQUIP_DISPLAY(parentPopFn, schParam, returnType) {
	
	$('#ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY_CMPY_CD').val(schParam.cmpyCd);
	$('#ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY_BRAND_CD').val(schParam.brandCd);
	
	// 공통코드 표시
	if(schParam.manageType == 'B') {
		$('<option/>', {'value': '0000', 'text': '본사'}).appendTo($('#ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY_STORE_NO'));	
	} else if(schParam.manageType == 'S') {
		$('<option/>', {'value': schParam.storeNo, 'text': '매장'}).appendTo($('#ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY_STORE_NO'));
		$('<option/>', {'value': '0000', 'text': '본사'}).appendTo($('#ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY_STORE_NO'));
	}
	
	fn_make_select(CODE_LIST, 'USE_YN', 'ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY_USE_YN');
	fn_make_select(CODE_LIST, 'DISPLAY_TYPE_CD', 'ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY_DISPLAY_TYPE_CD');
	
	let itp_BIZPOP_NK_EQUIP_DISPLAY_param = {};
	let itp_BIZPOP_NK_EQUIP_DISPLAY_search = false;

	const THIS_FORM_ID = '#ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY';
	const THIS_GIRD_ID = '#ITP_BIZPOP_NK_EQUIP_DISPLAY_jqGrid';
	const THIS_GIRD_PAGER = '#ITP_BIZPOP_NK_EQUIP_DISPLAY_jqGridPager';
	
	$('#ITP_BIZPOP_NK_EQUIP_DISPLAY').one('shown.bs.modal', function(e) {
		itp_fn_jqgrid_resize(THIS_GIRD_ID, '#ITP_BIZPOP_NK_EQUIP_DISPLAY_jqGrid_list', '');
		itp_fn_fire_window_resize();
	}).one('hidden.bs.modal', function(e) {
		$('#ITP_BIZPOP_NK_EQUIP_DISPLAY').remove();
	}).modal('show');
	
	$('#ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY_STORE_NO, #ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY_USE_YN, #ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY_DISPLAY_TYPE_CD').on('change', function() {
		itp_fn_BIZPOP_NK_EQUIP_DISPLAY_search(THIS_FORM_ID, THIS_GIRD_ID);	
	});

	$('#ITP_BIZPOP_NK_EQUIP_DISPLAY_BTN_SEARCH').on('click', function() {
		itp_fn_BIZPOP_NK_EQUIP_DISPLAY_search(THIS_FORM_ID, THIS_GIRD_ID);
	});
	
	$('#ITP_BIZPOP_NK_EQUIP_DISPLAY_BTN_SELECT').on('click', function() {		
		
		const rowKey = $(THIS_GIRD_ID).getGridParam('selrow');
	    if (!rowKey) {
	    	return;
	    }

		var list = [];
	    var selectedIds = $(THIS_GIRD_ID).getGridParam('selarrrow');

		if(selectedIds.length > 1) {
			$('#ITP_NK_EQUIP_DISPLAY_ERR_MSG').text('※ 1개만 선택해주세요.');
			return;	
		}
		
	    for (var i=selectedIds.length-1; i>=0; i--) {
			list.push($(THIS_GIRD_ID).jqGrid('getRowData', selectedIds[i]));	
		}
		parentPopFn(list);
		$('#ITP_BIZPOP_NK_EQUIP_DISPLAY').modal('hide'); // 팝업닫기
		
	});

	$('#ITP_BIZPOP_NK_EQUIP_DISPLAY_jqGridEmpty').on('click', function() {
		itp_fn_BIZPOP_NK_EQUIP_DISPLAY_empty.back();
		itp_BIZPOP_NK_EQUIP_DISPLAY_param.gridSize = 10;
		$(THIS_GIRD_ID).setGridParam({'postData': JSON.stringify(itp_BIZPOP_NK_EQUIP_DISPLAY_param)}).trigger('reloadGrid');
	});

	var itp_fn_BIZPOP_NK_EQUIP_DISPLAY_empty = {
		push: function() {
			let param = $(THIS_FORM_ID).serializeObject();
			itp_BIZPOP_NK_EQUIP_DISPLAY_param = param;
		},
		back: function() {
			$(THIS_FORM_ID + '_PRDT_TYPE').val(itp_BIZPOP_NK_EQUIP_DISPLAY_param.sprdtType);
			$(THIS_FORM_ID + '_CLASS_CD').val(itp_BIZPOP_NK_EQUIP_DISPLAY_param.sclassCd);
			$(THIS_FORM_ID + '_PRDT_NM').val(itp_BIZPOP_NK_EQUIP_DISPLAY_param.sprdtNm);
			$(THIS_FORM_ID + '_BARCODE_NO').val(itp_BIZPOP_NK_EQUIP_DISPLAY_param.sbarcodeNo);
		}
	};

	itp_fn_BIZPOP_NK_EQUIP_DISPLAY_empty.push();
	let param = $('#ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY').serializeObject();
	param.gridSize = 10;

	$(THIS_GIRD_ID).jqGrid({
		colModel: [
			{
				index: 'DISPLAY_NO', name: 'displayNo',
				label: '디스플레이번호', 
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'DISPLAY_NM', name: 'displayNm',
				label: '디스플레이명', 
				width: '15', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'DISPLAY_TYPE_NM', name: 'displayTypeNm',
				label: '화면구성', 
				width: '8', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'OUT_TYPE_NM', name: 'outTypeNm',
				label: '출력타입', 
				width: '8', fixed: false, align: 'center',
				sortable: false, hidden: false
			}
		],
		loadBeforeSend: function(jqXHR) {
		    jqXHR.setRequestHeader('X-AUTH-TOKEN', CONN_KEY);
		},
		postData: JSON.stringify(param),
		url: DOMAIN + NK_DID_EQUIP_GRID_LIST,
		pager: THIS_GIRD_PAGER,
		multiselect: true,
		loadComplete: function(data) {
			itp_fn_grid_load_complete(data, THIS_GIRD_ID, true, undefined, 'BIZPOP_NK_EQUIP_DISPLAY', itp_BIZPOP_NK_EQUIP_DISPLAY_search, itp_fn_BIZPOP_NK_EQUIP_DISPLAY_empty, true, data.gridRecords, false);
	    },
	    loadError: function(jqXHR, textStatus, errorThrown) {
	    	itp_fn_grid_load_error(jqXHR, textStatus, errorThrown);
	    },
	    onPaging: function(action) {
			param = $('#ITP_FORM_BIZPOP_NK_EQUIP_DISPLAY').serializeObject();
			param.gridSize = 10;
	    	itp_fn_grid_paging(THIS_GIRD_ID, action, param);
	    }
	}).navGrid(THIS_GIRD_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);
};

var itp_fn_BIZPOP_NK_EQUIP_DISPLAY_search = function(FORM_ID, GRID_ID) {	
	itp_BIZPOP_NK_EQUIP_DISPLAY_search = true;
	let param = $(FORM_ID).serializeObject();
	param.gridSize = 10;
	param.gridPage = $.jgrid.defaults.page;
	$(GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
};
